      program matmul
!
      USE numerics
!
      IMPLICIT NONE
!
! declarations
      real(rp),  allocatable,  dimension(:,:)  ::  a, b, c
!
      real(sp),  dimension(2)  ::  tarray
      real(rp)   ::  rMF, temps
      real(rp)   ::  tdeb, tfin
!
      external       etime
      real(sp)   ::  etime
!
      integer  ::  n, iloop
      integer  ::  i
      integer  ::  ierr = 0
!
!===================
! debut du programme
!===================
!
! lecture des parametres
      READ (5,*) n, iloop
!
! allocations dynamiques
      ALLOCATE ( a(n,n), b(n,n), c(n,n), STAT = ierr)
      IF ( ierr /= 0 ) THEN
         WRITE (6,1010) 'n = ', n
         WRITE (6,1010) 'iloop = ', iloop
         WRITE (6,1010) 'pbm allocation'
         STOP
      END IF
!
! initialisations
      call initmat (n,a,b,c)
!
! temps avant
      tdeb = etime (tarray)
!
! calcul matriciel
      do i = 1, iloop
         call pmm (n,a,b,c)
      end do
!
! temps apres
      tfin = etime (tarray)
!
! resultats
      temps = tfin - tdeb
      rMF = 2.0E-6 * (REAL(iloop) * REAL(n)**3) / temps
!
! affichage
      WRITE (6,201)
      WRITE (6,202) n
      WRITE (6,201)
      WRITE (6,203) temps, rMF
      WRITE (6,201)
!
  201 format ('+-----------+-----------+-----------+')
  202 format ('| n = ', I5, ' |   temps   |   MFlops  |')
  203 format ('| PMM       | ', F8.2, '  | ', F8.2, '  |')
!
! desallocation
      DEALLOCATE ( a, b, c )
!
 1010 FORMAT ( A, I5)
!
      STOP
      END PROGRAM matmul

