      !***********************************************************************!
      SUBROUTINE  calcul(  u,  f,  sx,  sy,  h)
      !***********************************************************************!
!
      USE MPI
!
      USE numerics
!
      IMPLICIT  NONE
!
!--Declaration des arguments
!
!Borne  inferieure  en  x
      INTEGER,  INTENT(IN)  ::  sx
!
!Borne  inferieure  en  y
      INTEGER,  INTENT(IN)  ::  sy
!
!Solution  u  a  l'iteration  n  et  n+1
      REAL(rp),  DIMENSION(sx-1:,sy-1:,0:),  INTENT(INOUT)   ::  u
!
!Second  membre
      REAL(rp),  DIMENSION(sx-1:,sy-1:),  INTENT(IN)  ::  f
!
!Pas
      REAL(rp),  INTENT(IN)  ::  h
!
!
!--Declaration des variales locales
!
!Compteurs
      INTEGER   ::  i,  j
!
!Borne  superieure  en  x
      INTEGER  ::  ex
!
!Borne  superieure  en  y
      INTEGER  ::  ey
!
!
      !***********************************************************************!
!
!Borne  superieure  suivant  x
      ex = UBOUND( u, DIM=1) - 1
!
!Borne  inferieure  suivant  y
      ey = UBOUND( u, DIM=2) - 1
!
      DO j = sy, ey
          DO i = sx, ex
             u(i,j,inew) = 0.25D0 * ( u(i-1,j,iold) + u(i,j+1,iold) &
                                    + u(i,j-1,iold) + u(i+1,j,iold) &
                                    - h * h * f(i,j) )
          END DO
      END DO

      END SUBROUTINE calcul

