      !***********************************************************************!
      SUBROUTINE  communication(  u,  sx,  sy,  type_ligne,  voisin,  comm2d)
      !***********************************************************************!
!
      USE MPI
!
      USE numerics
!
      IMPLICIT  NONE
!
!--Declaration des arguments
!
!Borne  inferieure  en  x
      INTEGER,  INTENT(IN)  ::  sx
!
!Borne  inferieure  en  y
      INTEGER,  INTENT(IN)  ::  sy
!
!Matrice
      REAL(rp),  DIMENSION(sx-1:,sy-1:,0:), INTENT(INOUT)  ::  u
!
!Type  type_ligne
      INTEGER,  INTENT(IN)  ::  type_ligne
!
!Tableau  contenant  les  voisins  du  domaine  courant
      INTEGER,  PARAMETER  ::  NB_VOISINS  =  4
      INTEGER,  PARAMETER  ::  N=1,  E=2,  S=3,  W=4
      INTEGER,  DIMENSION(NB_VOISINS),  INTENT(IN)  ::  voisin
!
! communicateur
      INTEGER,  INTENT(IN)  ::  comm2d
!
!
!--Declaration des variales locales
!
!Nombre  de  points  a  echanger  suivant  x
      INTEGER  ::  nombre_x
!
!Borne  superieure  en  x
      INTEGER  ::  ex
!
!Borne  superieure  en  y
      INTEGER  ::  ey
!
!Constantes  MPI
      INTEGER,  PARAMETER  ::  tag1=100
      INTEGER,  PARAMETER  ::  tag2=200
      INTEGER,  DIMENSION(MPI_STATUS_SIZE)  ::  status
!
      !***********************************************************************!
!
!Borne  superieure  suivant  x
      ex  =  UBOUND(u,  DIM=1)  -  1
!
!Borne  inferieure  suivant  y
      ey  =  UBOUND(u,  DIM=2)  -  1
!
!Nombre  de  points  a  echanger  suivant  x
      nombre_x  =  ex  -  sx  +  1
!
!Envoi  au  voisin  N  et  reception  du  voisin  S
      CALL  MPI_SENDRECV( &
            u(sx,ey,  iold), nombre_x, ITYPE_REAL, voisin(N), tag1, &
            u(sx,sy-1,iold), nombre_x, ITYPE_REAL, voisin(S), tag1, &
            comm2d, status, ierr )

!Envoi  au  voisin  S  et  reception  du  voisin  N
      CALL  MPI_SENDRECV( &
            u(sx,sy,  iold), nombre_x, ITYPE_REAL, voisin(S), tag2, &
            u(sx,ey+1,iold), nombre_x, ITYPE_REAL, voisin(N), tag2, &
            comm2d, status, ierr )

!Envoi  au  voisin  W  et  reception  du  voisin  E  en  utilisant  le  type  predefini
!type_ligne
      CALL  MPI_SENDRECV( &
            u(sx,  sy,iold), 1,        type_ligne, voisin(W), tag2, &
            u(ex+1,sy,iold), 1,        type_ligne, voisin(E), tag2, &
            comm2d, status, ierr )

!Envoi  au  voisin  E  et  reception  du  voisin  W  en  utilisant  le  type  predefini
!type_ligne
      CALL  MPI_SENDRECV( &
            u(ex,  sy,iold), 1,        type_ligne, voisin(E), tag2, &
            u(sx-1,sy,iold), 1,        type_ligne, voisin(W), tag2, &
            comm2d, status, ierr )

      END  SUBROUTINE  communication

