      !***********************************************************************!
      SUBROUTINE  equilibrage(  n,  mon_numproc,  mon_rang,  deb,  fin)
      !***********************************************************************!
!
      USE numerics
!
      IMPLICIT  NONE
!
!--Declaration  des  variables
!
!Nombre  total  de  points
      INTEGER,  INTENT(IN)   ::  n
!
!Indice  de  debut  et  de  fin
      INTEGER,  INTENT(OUT)  ::  deb,  fin
!
!Nombre  de  domaines  suivant  une  direction
      INTEGER,  INTENT(IN)   ::  mon_numproc
!
!Coordonnees  suivant  une  direction
      INTEGER,  INTENT(IN)   ::  mon_rang
!
!--Declaration des variales locales
!
!Nombre  de  points  pour  un  sous-domaine
      INTEGER   ::  nlocal
!
!Deficit  en  points
      INTEGER   ::  deficit

      !***********************************************************************!

!Calcul  du  nombre  de  points  dans  chaque  domaine
      nlocal  =  n  /  mon_numproc

!Calcul  de  la  borne  inferieure
      deb      =  mon_rang  *  nlocal  +  1
      deficit  =  MOD(  n,  mon_numproc)
      deb      =  deb +  MIN(  mon_rang,  deficit)

!reequilibrage  des  points  dans  les  domaines
      IF(  mon_rang  <  deficit  )  THEN
           nlocal  =  nlocal  +  1
      END  IF

!Calcul  de  la  borne  superieure
      fin  =  deb  +  nlocal  -  1

!Calcul  de  la  borne  superieure  pour  le  dernier  domaine
      IF((  fin  >  n)  .OR.  (  mon_rang  ==  mon_numproc  -  1)) fin  =  n

      END  SUBROUTINE  equilibrage

