      !***********************************************************************!
      SUBROUTINE  initialisation(  u,  f,  u_exact,  ntx,  h,  sx,  sy)
      !***********************************************************************!
!
      USE MPI
!
      USE numerics
!
      IMPLICIT  NONE
!
!--Declaration  des  arguments
!
!Nombre  de  points  total
      INTEGER,  INTENT(IN)  ::  ntx
!
!Borne  inferieure  et  superieure  en  x
      INTEGER,  INTENT(IN)  ::  sx
!
!Borne  inferieure  et  superieure  en  y
      INTEGER,  INTENT(IN)  ::  sy
!
!Solution  u  a  l'iteration  n  et  n+1
      REAL(rp),  DIMENSION(sx-1:,sy-1:, 0:),  INTENT(OUT)  ::  u
!
!Second  membre
      REAL(rp),  DIMENSION(sx-1:,sy-1:),  INTENT(OUT)  ::  f
!
!Solution exacte
      REAL(rp),  DIMENSION(sx-1:,sy-1:),  INTENT(OUT)  ::  u_exact
!
!Pas
      REAL(rp),  INTENT(OUT)  ::  h
!
!Compteurs
      INTEGER   ::  i,  j
!
!Coordonnees  globales  suivant  x  et  y
      REAL(rp)  ::  x,  y
!
!Borne  superieure  en  x
      INTEGER  ::  ex
!
!Borne  superieure  en  y
      INTEGER  ::  ey
!
!
      !***********************************************************************!
!
!Initialisation  des  matrices
      DO j = sy - 1, ey + 1
         DO i = sx - 1, ex + 1
            u (i,j,iold) = 0.0_rp
            u (i,j,inew) = 0.0_rp
            f (i,j)      = 0.0_rp
            u_exact(i,j) = 0.0_rp
         END DO
      END DO
!
!Pas
      h  =  1.0_rp  /  real( ntx + 1, rp)
!
!Borne  superieure  suivant  x
      ex  =  UBOUND(  u,  DIM=1)  -  1
!
!Borne  inferieure  suivant  y
      ey  =  UBOUND(  u,  DIM=2)  -  1
!
!Initialisation  du  second  membre  et  calcul  de  la  solution  exacte
      DO  j  =  sy,  ey
          DO  i  =  sx,  ex
!
              x  =  i*h
              y  =  j*h
              f(i,j)  =  2 * ( x*(x-1) + y*(y-1) )
              u_exact(i,j)   =  x * y * (x-1) * (y-1)
!
          END  DO
      END  DO
!
      END  SUBROUTINE  initialisation

