interface

 SUBROUTINE  initialisation(  u,  f,  u_exact,  ntx,  h,  sx,  sy)
      USE MPI
      USE numerics
      IMPLICIT  NONE
      INTEGER,  INTENT(IN)  ::  ntx
      INTEGER,  INTENT(IN)  ::  sx
      INTEGER,  INTENT(IN)  ::  sy
      REAL(rp),  DIMENSION(sx-1:,sy-1:,0:),  INTENT(OUT)  ::  u
      REAL(rp),  DIMENSION(sx-1:,sy-1:),     INTENT(OUT)  ::  f
      REAL(rp),  DIMENSION(sx-1:,sy-1:),     INTENT(OUT)  ::  u_exact
      REAL(rp),  INTENT(OUT)  ::  h
 END  SUBROUTINE  initialisation

 SUBROUTINE  communication(  u,  sx,  sy,  type_ligne,  voisin,  comm2d)
      USE MPI
      USE numerics
      IMPLICIT  NONE
      INTEGER,  INTENT(IN)  ::  sx
      INTEGER,  INTENT(IN)  ::  sy
      REAL(rp),  DIMENSION(sx-1:,sy-1:, 0:), INTENT(INOUT)  ::  u
      INTEGER,  INTENT(IN)  ::  type_ligne
      INTEGER,  PARAMETER  ::  NB_VOISINS  =  4
      INTEGER,  DIMENSION(NB_VOISINS),  INTENT(IN)  ::  voisin
      INTEGER,  INTENT(IN)  ::  comm2d
 END  SUBROUTINE  communication

 SUBROUTINE  calcul (  u,  f,  sx,  sy,  h)
      USE MPI
      USE numerics
      IMPLICIT  NONE
      INTEGER,  INTENT(IN)  ::  sx
      INTEGER,  INTENT(IN)  ::  sy
      REAL(rp),  DIMENSION(sx-1:,sy-1:,0:),  INTENT(IN)   ::  u
      REAL(rp),  DIMENSION(sx-1:,sy-1:),     INTENT(IN)   ::  f
      REAL(rp),  INTENT(IN)  ::  h
 END  SUBROUTINE  calcul

 FUNCTION  erreur(  u,  sx,  sy)
      USE MPI
      USE numerics
      IMPLICIT  NONE
      INTEGER,  INTENT(IN)  ::  sx
      INTEGER,  INTENT(IN)  ::  sy
      REAL(rp)   ::  erreur
      REAL(rp),  DIMENSION(sx-1:,sy-1:,0:),  INTENT(IN)  ::  u
 END  FUNCTION  erreur

end interface

