      !***********************************************************************!
      SUBROUTINE  voisinage(  comm2d,  voisin)
      !***********************************************************************!
!
      USE MPI
!
      USE numerics
!
      IMPLICIT  NONE
!
!--Declaration  des  arguments
!
!Tableau  contenant  les  voisins  du  domaine  courant
      INTEGER,  PARAMETER  ::  NB_VOISINS  =  4
      INTEGER,  PARAMETER  ::  N=1,  E=2,  S=3,  W=4
      INTEGER,  DIMENSION(NB_VOISINS),  INTENT(OUT)   ::  voisin
!
!Constantes  MPI
      INTEGER,  INTENT(IN)  ::  comm2d
!
!
      !***********************************************************************!
!
!Initialisation  du  tableau  voisin
      voisin  =  MPI_PROC_NULL
!
!Recherche  des  voisins  Ouest  et  Est
      CALL  MPI_CART_SHIFT(  comm2d,  0,  1,  voisin(W),  voisin(E),  ierr)
!
!Recherche  des  voisins  Nord  et  sud
      CALL  MPI_CART_SHIFT(  comm2d,  1,  1,  voisin(S),  voisin(N),  ierr)
!
      END  SUBROUTINE  voisinage

